import { ActionRowBuilder, ButtonBuilder, ButtonStyle, CacheType, ChatInputCommandInteraction, EmbedBuilder, Message } from "discord.js";
import ConfigManager from "./ConfigManager";
import axios from "axios";
import UserI from "../types/UserI";
import MessageI from "../types/MessageI";
import { channel } from "diagnostics_channel";

var isSyncing = false

export default class ChatController {
  public constructor() { }
  public async getMessages() {
    try {
      const { data, status } = await axios.get<MessageI[]>(`${process.env.ECO_API_BASE || "https://eco.kamgames.xyz"}/api/v1/chat`, {
        timeout: 5000,
        headers: {
          "X-API-Key": process.env.ECO_API_KEY
        }
      });

      if (status !== 200) return false

      console.log(data)

      return true
    } catch (error) {
      console.log(error)
    }
    return false
  }
  public async syncMessageWithDiscord() {
    if (isSyncing) return true

    isSyncing = true

    if (!global.config.chatChannelId) {
      isSyncing = false
      return false
    }

    try {
      const ch = await global.client.channels.fetch(config.chatChannelId)

      const t = global.config.messageTime + 0.001
      const time = (t / 3600 / 24).toFixed(100)
      const { data, status } = await axios.get<MessageI[]>(
        `${process.env.ECO_API_BASE || "https://eco.kamgames.xyz"}/api/v1/chat?startDay=${time}`, {
        timeout: 5000,
        headers: {
          "X-API-Key": process.env.ECO_API_KEY
        }
      });

      if (status !== 200) {
        isSyncing = false
        return false
      }

      if (data.length === 0) {
        isSyncing = false
        return true
      }

      const messages = data

      if (!ch || !ch.isTextBased()) {
        isSyncing = false
        return false
      }

      messages.forEach(async m => {
        if (global.config.messageTime < m.Timestamp)
          global.config.messageTime = m.Timestamp
        // const me = new EmbedBuilder()
        // me.setDescription(m.Text)
        // me.setAuthor({ name: m.Sender })
        // ch.send({ embeds: [me] })
        console.log(`${m.Sender}: ${m.Text}`)
        await ch.send(`**${m.Sender}**: ${m.Text}`)
      })

      isSyncing = false
      return true
    } catch (error) {
      console.log(error)
    }

    isSyncing = false
    return false
  }
}